<template>
  <single-panel>
    <div class="websocket-row">
      <h1 :class="connected ? 'connected' : ''">
        test websockets
      </h1>
    </div>
    <div class="websocket-row">
      <ob-input type="text" v-model="endpoint"/>
      <ob-button label="connect" @click="connect" :disabled="connected"/>
    </div>

    <div class="websocket-row">
      <h2>Received messages</h2>
      <ul v-if="receivedMessages.length">
        <li v-for="(message, index) in receivedMessages" :key="index">
          {{message}}
        </li>
      </ul>
      <p v-else class="empty">
        No messages received yet
      </p>
    </div>
  </single-panel>
</template>

<script>
import SockJS from "sockjs-client";
import Stomp from "webstomp-client";
import { getCookie } from '@/utils/cookie';
import singlePanel from 'common-components/src/obComponents/obSinglePanels';
import obButton from 'common-components/src/obComponents/obButton';
import obInput from 'common-components/src/obComponents/obInput';
  export default {
    name: 'websocketsTest',

    components: {
      singlePanel,
      obButton,
      obInput,
    },

    data() {
      return {
        token: getCookie('auth_token'),
        endpoint: 'https://dev.oboz.app/oboz2-notificator-websocket-sender/notificator-ws-sender',
        receivedMessages: [],
        message: null,
        connected: false
      }
    },

    methods: {
      connect() {
        this.socket = new SockJS(this.endpoint);
        this.stompClient = Stomp.over(this.socket);

        this.stompClient.connect(
          {token: this.token},
          frame => {
            this.connected = true;
            var sessionId = /\/([^/]+)\/websocket/.exec(this.socket._transport.url)[1];
            console.log("session id: " + sessionId);
            console.log('Connected: ' + frame);
            this.stompClient.subscribe('/user/queue/reply', messageOutput => {
              this.receivedMessages.push(JSON.parse(messageOutput.body));
            });
          },
          error => {
            console.error(error);
            this.connected = false;
          }
        );
      },

      send() {
        console.log("Send message:" + this.message);
        if (this.stompClient && this.stompClient.connected) {
          const msg = { name: this.message };
          console.log(JSON.stringify(msg));
          this.stompClient.send(this.endpoint, JSON.stringify(msg), {});
        }
      },
    },
  }
</script>

<style lang="scss" scoped>
@import '~common-components/src/static/css/variables';
@import '~common-components/src/static/css/mixins';

.websocket-row {
  display: flex;
  align-items: center;
  flex-wrap: wrap;
  padding: 20px;

  .ob-input-container {
    flex-grow: 1;
    margin-right: 10px;
  }
}

h1 {
  text-transform: uppercase;
  font-size: 2rem;
  line-height: 1;
  position: relative;
  display: flex;
  align-items: center;

  &:after {
    content: '';
    width: 15px;
    height: 15px;
    position: relative;
    top: -2px;
    margin-left: 10px;
    border-radius: 50%;
    background-color: red;
  }

  &.connected:after {
    background-color: green;
  }
}

.empty {
  width: 100%;
  height: 100px;
  padding: 2em 0;
  font-size: 1.5rem;
  font-weight: 700;
  color: $gray-slate
}
</style>
